<template>
  <div class="row h-100 oneThirdClickable no-gutters">

    <div class="col-6"></div>
    <div :class="{'justify-content-between': $mq !== 'mobile', 'justify-content-end': $mq === 'mobile'}"
      class="col-6 p-2 d-flex flex-column"
    >

      <div v-if="$mq !== 'mobile'"></div>

      <div class="d-flex flex-column align-items-center justify-content-around h-80">

        <div class="row d-flex justify-content-center no-gutters">
          <div class="col-md-11 col-12">
            <div style="text-align: center">
              <h6 :style="data['headline2StyleObj']" v-html="data['email-modal-subhead']"></h6>
              <h5 :style="data['headline3StyleObj']" v-html="data['email-modal-body-copy']"></h5>
            </div>
          </div>
        </div>

        <div class="row d-flex justify-content-center no-gutters w-100">

          <div v-if="submitted" class="col-md-9 col-12" style="background-color: #000000">

            <div class="py-4" style="color:white;text-align: center;white-space: pre;line-height: 1">

              <h1 class="m-0" style="font-size: 1.7rem" ><b>Thank You</b></h1>
              <h5 class="m-0" style="font-size: 1.2rem" >Please check your email.</h5>
              <small>(or your spam folder)</small>

            </div>

          </div>

          <div v-else class="col-md-11 col-12">

            <div v-if="validationErr" class="row col-12 d-flex justify-content-center">
              <div class="error-message">
                Please Provide/Complete Email Field.
              </div>
            </div>


            <div class="input-group px-2 pt-2">
              <input v-model="firstName" class="form-control form-rounded input-lg-left" placeholder="First Name"
                type="text">
              <input v-model="lastName" class="form-control form-rounded input-lg-right" placeholder="Last Name"
                type="text">
            </div>

            <div class="p-2" style="text-align: center;line-height: 1!important;">
              <input v-model="email" class="form-control form-rounded input-lg" placeholder="Email Address"
                type="email">
            </div>

            <div class="px-2" style="text-align: center;">
              <button class="btn btn-dark button-lg" type="button" @click="CtaButtonClick">SUBMIT</button>
            </div>


          </div>

        </div>

        <div class="row d-flex justify-content-center no-gutters p-2">
          <div class="col-md-11 col-12">
            <div style="text-align: center;line-height: 1!important;">
              <small>{{ data['email-modal-legal-copy'] }}</small>
            </div>
          </div>
        </div>

      </div>

    </div>

  </div>


</template>

<script>

module.exports = {
  props: ['data', 'pauseAudio'],
  components: {
    'custom-button': httpVueLoader('components/buttons/button.vue')
  },
  data() {
    return {
      soundEffect: new Audio(this.data['cta-audio']),
      email: null,
      validationErr: false,
      firstName: null,
      lastName: null,

      submitted: false
    }
  },
  methods: {
    CtaButtonClick() {
      let validationErrs = []
      validationErrs.email = !this.email
      validationErrs.firstName = !this.firstName
      validationErrs.LastName = !this.lastName
      console.log('validationErrs ', validationErrs)

      if (Object.keys(validationErrs).every((k) => !validationErrs[k])) {

        const formattedEmailLink = this.data['email-link'].replace('prospect+first+name', this.firstName)
          .replace('prospect+last+name', this.lastName).replace('prospect+email', this.email)

        this.validationErr = false

        const dataForX40 = { xKey: 'X40', extra: this.firstName }
        this.$store.commit('fireAnalytics', dataForX40)

        const dataForX41 = { xKey: 'X41', extra: this.lastName }
        this.$store.commit('fireAnalytics', dataForX41)

        const dataForX42 = { xKey: 'X42', extra: this.email }
        this.$store.commit('fireAnalytics', dataForX42)

        // fire webinar Api
        const webinarData = {
          "image-thumbnail": this.data["email-image-thumbnail"],
          "email-from-subject": this.data['email-from-subject'],
          "email-from-name": this.data["email-from-name"],
          "recipient-email": this.email,
          "recipient-firstname": this.firstName,
          "recipient-lastname": this.lastName,
          "link": formattedEmailLink
        }
        window.axios.post(this.data['external_endpoint'] + 'webinar/' + this.data['xid_param'], webinarData);


        this.email = null
        this.firstName = null
        this.lastName = null

        this.submitted = true

        setTimeout(() => {
          this.submitted = false
          $('#emailModal').modal('hide')
        }, 8000)

        // $('#emailModal').modal('hide')

        // window.open(window.getLink(this.data['email-modal-redirect-link']), "_blank")

      } else {
        this.validationErr = true
        this.submitted = false
      }
    }
  },
  mounted() {
    this.submitted = false
    // this.soundEffect.play()
  },
  beforeDestroy() {
    // this.soundEffect.pause()
  }
}
</script>
<style>
</style>
